{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit parseWords;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, strutils;

function ParseToWords(const aString: string; separators: TSysCharSet): TStringList;

implementation

function ParseToWords(const aString: string; separators: TSysCharSet
  ): TStringList;
var
  c: Char;
  s: string = '';
  buildingAWord: boolean = False;
begin
  if Length(aString)=0
   then begin
         Result := nil;
         Exit;
        end;
  if separators = []
   then separators:= WordDelimiters;

  Result := TStringList.Create;
  for c in aString do
   case (c in separators) of
    False: begin
            if not buildingAWord
             then buildingAWord:= True;
            s := s + c;
           end;
    True : begin
            if buildingAWord
             then begin
                   buildingAWord:= False;
                   Result.Add(s);
                   s := '';
                  end;
           end;
   end;
  if (Length(s) > 0) then Result.Add(s);
end;

end.

