program cleanfile;

{$mode objfpc}{$H+}

uses sysutils;

function Cleaned(const st: string): string;
var i, len: integer;
begin
  Result:='';
  len := Length(st);
  for i := 1 to len do
  begin
    case st[i] of
     #9: AppendStr(Result, ' '); // change tab to space
     #32: if (i < len) and (st[i+1] <> #32) // process space characters
           then AppendStr(Result, st[i])
          else Continue;
     else AppendStr(Result, st[i])
    end;
  end;

end;

var fn, s: string;
    inText, outText: TextFile;
    lineCount: integer = 0;
begin
  if (Paramcount=0) then
   begin
     WriteLn('You must specify the name of the file to clean as a command line parameter');
     ReadLn;
     Halt;
   end;

  fn:= ParamStr(1);
  try
    AssignFile(inText, fn);
    Reset(inText);
    try
      AssignFile(outText, fn+'cleaned');
      Rewrite(outText);
      while not eof(inText) do
       begin
         ReadLn(inText, s);
         WriteLn(outText, Cleaned(s));
         Inc(lineCount);
       end;
    finally
      CloseFile(outText);
    end;
  finally
    CloseFile(inText);
  end;
  WriteLn(lineCount,' lines of ',fn,' processed and written to a new');
  WriteLn('cleaned file named "',fn,'cleaned"');
  WriteLn('Press [Enter] to Exit');
  ReadLn;
end.

